/*
** mod_chm -- an apache2 module that provides possibility to explore 
**            file in CHM format.
**
** Copyright (C) 2005 Pavel Frolov <snake4d@pisem.net>
** 
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
** 
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
** GNU General Public License for more details.
** 
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place, Suite 330, Boston, MA, 02111-1307, USA or visit:
** http://www.gnu.org
*/


#ifndef __MODCHM_H
#define __MODCHM_H

#define CHM_MAGIC_TYPE "text/chm"
#define CHM_MAGIC_STREAM "application/chm"

#define CHM_ROOT "/"
#define CHM_INDEX "TOC"
#define CHM_DOWNLOAD "DOWNLOAD"
#define CHM_TITLE "TITLE"

#define BUF_SIZE 4096
#define MAX_TAG 1024

char* mainHtml = "<html>\n<head>\n<title>%s</title>\n</head>\n"
"<frameset rows=\"40,*\">\n"
"  <frame name=\"title\" src=\"?"
CHM_TITLE
"\" frameborder=\"0\" noresize marginwidth=\"0\" marginheight=\"0\">\n"
"  <frameset cols=\"200,*\">\n"
"    <frame name=\"toc\" src=\"%s%s?"
CHM_INDEX
"\">\n"
"    <frame name=\"content\">\n"
"  </frameset>\n</frameset>\n</html>"; 

char* titleHtml = "<html>\n<head>\n</head>\n"
"<body>\n<table width=\"100%\">\n <tr><td align=\"center\">"
"<p style=\"font-size:14pt; font-weight: bold;\">%s</p></td>\n"
"<td><a href=\"?"
CHM_DOWNLOAD
"\">Download</a></td></tr>\n"
"</table>\n</body>\n</html>";

char* tocHeader = "<html>\n<head>\n"
"    <title>TreeView</title>\n"
"    <style type=\"text/css\">\n"
"    <!--\n"
"    .directory { font-size: 10pt; font-weight: bold; }\n"
"    .directory h3 { margin: 0px; margin-top: 1em; font-size: 11pt; }\n"
"    .directory p { margin: 0px; white-space: nowrap; }\n"
"    .directory div { display: none; margin: 0px; }\n"
"    .directory img { vertical-align: middle; }\n"
"    -->\n"
"    </style>\n"
"<script type=\"text/javascript\">\n"
"<!-- // Hide from old browsers\n"
"   function findChildNode(node, name) \n"
"    {\n"
"      var temp;\n"
"      if (node == null)\n"
"      {\n"
"        return null;\n"
"      }\n"
"      node = node.firstChild;\n"
"      while (node != null)\n"
"      {\n"
"        if (node.nodeName == name)\n"
"        {\n"
"          return node;\n"
"        }\n"
"        temp = findChildNode(node, name);\n"
"        if (temp != null)\n"
"        {\n"
"          return temp;\n"
"        }\n"
"        node = node.nextSibling;\n"
"      }\n"
"      return null;\n"
"    }\n\n"
"    function firstClick( )\n"
"    {\n"
"       var link = document.getElementById(\"first\");\n"
"       var frm = window.parent.frames;\n"
"       for (var i = 0; i < frm.length; i++) \n"
"		if(frm[i].name == \"content\") frm[i].location.href = link.href;"
"    }\n\n"
"    function toggleFolder(id, imageNode)\n"
"    {\n"
"      var folder = document.getElementById(id);\n"
"      var l = 0;\n"
"      var vl = \"mod_chm_images/blank.png\";\n"
"      if (imageNode != null && imageNode.nodeName != \"IMG\")\n"
"      {\n"
"        imageNode = findChildNode(imageNode, \"IMG\");\n"
"        if (imageNode!=null) l = imageNode.src.length;\n"
"      }\n"
"      if (folder != null)\n"
"      {\n"
"      if (folder.style.display == \"block\")\n"
"      {\n"
"        while (imageNode != null &&\n"
"               imageNode.src.substring(l-vl.length,l) == vl)\n"
"        {\n"
"          imageNode = imageNode.nextSibling;\n"
"          l = imageNode.src.length;\n"
"        }\n"
"        if (imageNode != null)\n"
"        {\n"
"          l = imageNode.src.length;\n"
"          imageNode.nextSibling.src = \"mod_chm_images/folderclosed.png\";\n"
"          if (imageNode.src.substring(l-28,l) == \"mod_chm_images/minusnode.png\")\n"
"          {\n"
"            imageNode.src = \"mod_chm_images/plusnode.png\";\n"
"          }\n"
"        }\n"
"        folder.style.display = \"none\";\n"
"      }\n"
"      else\n"
"      {\n"
"        while (imageNode != null &&\n"
"               imageNode.src.substring(l-vl.length,l) == vl)\n"
"        {\n"
"          imageNode = imageNode.nextSibling;\n"
"          l = imageNode.src.length;\n"
"        }\n"
"        if (imageNode != null)\n"
"        {\n"
"          l = imageNode.src.length;\n"
"          imageNode.nextSibling.src = \"mod_chm_images/folderopen.png\";\n"
"          if (imageNode.src.substring(l-27,l) == \"mod_chm_images/plusnode.png\")\n"
"          {\n"
"            imageNode.src = \"mod_chm_images/minusnode.png\";\n"
"          }\n"
"        }\n"
"        folder.style.display = \"block\";\n"
"      }\n"
"      }\n"
"    }\n\n"
"    // End script hiding -->\n"
"    </script>\n"
"  </head>\n"
"<body bgcolor=\"#ffffff\" onload=\"firstClick()\">\n"
"<div class=\"directory\">\n"
"<div style=\"display: block;\">";

char* tocFooter = "\n</div>\n</div>\n</body>\n</html>";

#endif /* __MODCHM_H */

